<?php
    require('../components/utils.php');
    require('../components/db_config.php');
    adminLogin();

    if(isset($_POST['add_room'])){
        $accommodation = filteration(json_decode($_POST['accommodation']));
        $additional_accomm = filteration(json_decode($_POST['additional_accomm']));

        $frm_data = filteration($_POST);
        $flag = 0;
        $q1 = "INSERT INTO `rooms`(`name`, `area`, `price`, `quantity`, `adult`, `children`, `detail`) VALUES (?, ?, ?, ?, ?, ?, ?)";
        $values = [$frm_data['name'], $frm_data['area'], $frm_data['price'], $frm_data['quantity'], $frm_data['adult'], $frm_data['children'], $frm_data['detail']];

        if(insert($q1, $values, 'siiiiis')){
            $flag = 1;
        }
        $room_id = mysqli_insert_id($con);

        $q2 = "INSERT INTO `room_accommodation`(`room_id`, `accommodation_id`) VALUES (?, ?)";

        if($stmt = mysqli_prepare($con, $q2)){
            foreach($accommodation as $a){
                mysqli_stmt_bind_param($stmt, 'ii', $room_id, $a);
                mysqli_stmt_execute($stmt);
            }
            mysqli_stmt_close($stmt);
        } else{
            $flag = 0;
            die('Query cannot be prepared - insert');
        }

        //room additional accommodation
        $q3 = "INSERT INTO `room_additionalAccom`(`room_id`, `additionalAccom_id`) VALUES (?, ?)";

        if($stmt = mysqli_prepare($con, $q3)){
            foreach($additional_accomm as $a){
                mysqli_stmt_bind_param($stmt, 'ii', $room_id, $a);
                mysqli_stmt_execute($stmt);
            }
            mysqli_stmt_close($stmt);
        } else{
            $flag = 0;
            die('Query cannot be prepared - insert');
        }

        if($flag){
            echo 1;
        } else{
            echo 0;
        }
    }

    if(isset($_POST['get_all_rooms'])){
        $res = selectAll('rooms');
        $i = 0;
        $data = "";

        while($row = mysqli_fetch_assoc($res)){
            if($row['status']==1){
                $status = "
                    <button onclick='toggleStatus($row[id], 0)' class='btn-third'>Active</button>
                ";
            } else{
                $status = "
                    <button onclick='toggleStatus($row[id], 1)' class='btn-cancel'>Inactive</button>
                ";
            }

            $data.="
                <tr>
                    <td>$i</td>
                    <td>$row[name]</td>
                    <td>$row[area] sq.ft.</td>
                    <td>
                        <span style='font-weight:600;'>Adult:</span> $row[adult]</span><br>
                        <span style='font-weight:600;'>Children:</span> $row[children]
                    </td>
                    <td>$$row[price]</td>
                    <td>$row[quantity]</td>
                    <td>$status</td>
                    <td>
                        <button type='button' onclick='edit_room($row[id])' class='btn-third' data-bs-toggle='modal' data-bs-target='#edit-room'>Edit</button>
                    </td>
                </tr>
            ";
            $i++;
        }
        echo $data;
    }

    if(isset($_POST['get_room'])){
        $frm_data = filteration($_POST);
        $res1 = select("SELECT * FROM `rooms` WHERE `id`=?", [$frm_data['get_room']], 'i');
        $res2 = select("SELECT * FROM `room_accommodation` WHERE `room_id`=?", [$frm_data['get_room']], 'i');
        $res3 = select("SELECT * FROM `room_additionalAccom` WHERE `room_id`=?", [$frm_data['get_room']], 'i');

        $roomdata = mysqli_fetch_assoc($res1);
        $accommodation = [];
        $additional_accomm = [];

        if(mysqli_num_rows($res2)>0){
            while($row = mysqli_fetch_assoc($res2)){
                array_push($accommodation, $row['accommodation_id']);
            }
        }
        if(mysqli_num_rows($res3)>0){
            while($row = mysqli_fetch_assoc($res3)){
                array_push($additional_accomm, $row['additionalAccom_id']);
            }
        }
        $data = ["roomdata" => $roomdata, "accommodation" => $accommodation, "additional_accomm" => $additional_accomm];
        $data = json_encode($data);

        echo $data;
    }

    if(isset($_POST['edit_room'])){
        
    }

    if(isset($_POST['toggleStatus'])){
        $frm_data = filteration($_POST);
        $q = "UPDATE `rooms` SET `status`=? WHERE `id`=?";
        $values = [$frm_data['value'], $frm_data['toggleStatus']];

        if(update($q, $values, 'ii')){
            echo 1;
        } else{
            echo 0;
        }
    }
?>